Index: branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/TRD/trdglo.F90
===================================================================
--- branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/TRD/trdglo.F90	(revision 8093)
+++ branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/TRD/trdglo.F90	(revision 8143)
@@ -9,26 +9,25 @@
 
    !!----------------------------------------------------------------------
-   !!   trd_glo      : domain averaged budget of trends (including kinetic energy and T^2 trends)
-   !!   glo_dyn_wri  : print dynamic trends in ocean.output file
-   !!   glo_tra_wri  : print global T & T^2 trends in ocean.output file
-   !!   trd_glo_init : initialization step
+   !!   trd_glo       : domain averaged budget of trends (including kinetic energy and T^2 trends)
+   !!   glo_dyn_wri   : print dynamic trends in ocean.output file
+   !!   glo_tra_wri   : print global T & T^2 trends in ocean.output file
+   !!   trd_glo_init  : initialization step
    !!----------------------------------------------------------------------
-   USE oce             ! ocean dynamics and tracers variables
-   USE dom_oce         ! ocean space and time domain variables
-   USE sbc_oce         ! surface boundary condition: ocean
-   USE trd_oce         ! trends: ocean variables
-   USE phycst          ! physical constants
-   USE ldftra          ! lateral diffusion: eddy diffusivity & EIV coeff.
-   USE ldfdyn          ! ocean dynamics: lateral physics
-   USE zdf_oce         ! ocean vertical physics
-   USE zdfbfr          ! bottom friction
-   USE zdfddm          ! ocean vertical physics: double diffusion
-   USE eosbn2          ! equation of state
-   USE phycst          ! physical constants
+   USE oce            ! ocean dynamics and tracers variables
+   USE dom_oce        ! ocean space and time domain variables
+   USE sbc_oce        ! surface boundary condition: ocean
+   USE trd_oce        ! trends: ocean variables
+   USE phycst         ! physical constants
+   USE ldftra         ! lateral diffusion: eddy diffusivity & EIV coeff.
+   USE ldfdyn         ! ocean dynamics: lateral physics
+   USE zdf_oce        ! ocean vertical physics
+   USE zdfdrg         ! ocean vertical physics: bottom friction
+   USE zdfddm         ! ocean vertical physics: double diffusion
+   USE eosbn2         ! equation of state
+   USE phycst         ! physical constants
    !
-   USE lib_mpp         ! distibuted memory computing library
-   USE in_out_manager  ! I/O manager
-   USE iom             ! I/O manager library
-   USE wrk_nemo        ! Memory allocation
+   USE lib_mpp        ! distibuted memory computing library
+   USE in_out_manager ! I/O manager
+   USE iom            ! I/O manager library
 
    IMPLICIT NONE
@@ -77,9 +76,7 @@
       INTEGER ::   ikbu, ikbv      ! local integers
       REAL(wp)::   zvm, zvt, zvs, z1_2rau0   ! local scalars
-      REAL(wp), POINTER, DIMENSION(:,:)  :: ztswu, ztswv, z2dx, z2dy   ! 2D workspace 
-      !!----------------------------------------------------------------------
-
-      CALL wrk_alloc( jpi, jpj, ztswu, ztswv, z2dx, z2dy )
-
+      REAL(wp), DIMENSION(jpi,jpj)  :: ztswu, ztswv, z2dx, z2dy   ! 2D workspace 
+      !!----------------------------------------------------------------------
+      !
       IF( MOD(kt,nn_trd) == 0 .OR. kt == nit000 .OR. kt == nitend ) THEN
          !
@@ -123,8 +120,8 @@
                DO jj = 1, jpjm1
                   DO ji = 1, jpim1
-                     zvt = ptrdx(ji,jj,jk) * tmask_i(ji+1,jj  ) * tmask_i(ji,jj) * umask(ji,jj,jk)   &
-                        &                  * e1u    (ji  ,jj  ) * e2u    (ji,jj) * e3u_n(ji,jj,jk)
-                     zvs = ptrdy(ji,jj,jk) * tmask_i(ji  ,jj+1) * tmask_i(ji,jj) * vmask(ji,jj,jk)   &
-                        &                  * e1v    (ji  ,jj  ) * e2v    (ji,jj) * e3u_n(ji,jj,jk)
+                     zvt = ptrdx(ji,jj,jk) * tmask_i(ji+1,jj) * tmask_i(ji,jj) * umask(ji,jj,jk)   &
+                        &                                     * e1e2u  (ji,jj) * e3u_n(ji,jj,jk)
+                     zvs = ptrdy(ji,jj,jk) * tmask_i(ji,jj+1) * tmask_i(ji,jj) * vmask(ji,jj,jk)   &
+                        &                                     * e1e2v  (ji,jj) * e3u_n(ji,jj,jk)
                      umo(ktrd) = umo(ktrd) + zvt
                      vmo(ktrd) = vmo(ktrd) + zvs
@@ -138,8 +135,8 @@
                DO jj = 1, jpjm1
                   DO ji = 1, jpim1
-                     zvt = ( utau_b(ji,jj) + utau(ji,jj) ) * tmask_i(ji+1,jj  ) * tmask_i(ji,jj) * umask(ji,jj,jk)   &
-                        &                       * z1_2rau0 * e1u    (ji  ,jj  ) * e2u    (ji,jj)
-                     zvs = ( vtau_b(ji,jj) + vtau(ji,jj) ) * tmask_i(ji  ,jj+1) * tmask_i(ji,jj) * vmask(ji,jj,jk)   &
-                        &                       * z1_2rau0 * e1v    (ji  ,jj  ) * e2v    (ji,jj) * e3u_n(ji,jj,jk)
+                     zvt = ( utau_b(ji,jj) + utau(ji,jj) ) * tmask_i(ji+1,jj) * tmask_i(ji,jj) * umask(ji,jj,jk)   &
+                        &                                                     * z1_2rau0       * e1e2u(ji,jj)
+                     zvs = ( vtau_b(ji,jj) + vtau(ji,jj) ) * tmask_i(ji,jj+1) * tmask_i(ji,jj) * vmask(ji,jj,jk)   &
+                        &                                                     * z1_2rau0       * e1e2v(ji,jj)
                      umo(jpdyn_tau) = umo(jpdyn_tau) + zvt
                      vmo(jpdyn_tau) = vmo(jpdyn_tau) + zvs
@@ -151,5 +148,5 @@
             IF( ktrd == jpdyn_atf ) THEN     ! last trend (asselin time filter)
                !
-               IF( ln_bfrimp ) THEN                   ! implicit bfr case: compute separately the bottom friction 
+               IF( ln_drgimp ) THEN                   ! implicit drag case: compute separately the bottom friction 
                   z1_2rau0 = 0.5_wp / rau0
                   DO jj = 1, jpjm1
@@ -157,6 +154,6 @@
                         ikbu = mbku(ji,jj)                  ! deepest ocean u- & v-levels
                         ikbv = mbkv(ji,jj)
-                        zvt = bfrua(ji,jj) * un(ji,jj,ikbu) * e1u(ji,jj) * e2v(ji,jj)
-                        zvs = bfrva(ji,jj) * vn(ji,jj,ikbv) * e1v(ji,jj) * e2v(ji,jj)
+                        zvt = 0.5*( rCdU_bot(ji+1,jj)+rCdU_bot(ji,jj) ) * un(ji,jj,ikbu) * e1e2u(ji,jj)
+                        zvs = 0.5*( rCdU_bot(ji,jj+1)+rCdU_bot(ji,jj) ) * vn(ji,jj,ikbv) * e1e2v(ji,jj)
                         umo(jpdyn_bfri) = umo(jpdyn_bfri) + zvt
                         vmo(jpdyn_bfri) = vmo(jpdyn_bfri) + zvs
@@ -165,4 +162,5 @@
                   END DO
                ENDIF
+!!gm top drag case is missing 
                ! 
                CALL glo_dyn_wri( kt )                 ! print the results in ocean.output
@@ -178,6 +176,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj, ztswu, ztswv, z2dx, z2dy )
-      !
    END SUBROUTINE trd_glo
 
@@ -193,8 +189,6 @@
       INTEGER  ::   ji, jj, jk   ! dummy loop indices
       REAL(wp) ::   zcof         ! local scalar
-      REAL(wp), POINTER, DIMENSION(:,:,:)  ::  zkx, zky, zkz, zkepe  
-      !!----------------------------------------------------------------------
-
-      CALL wrk_alloc( jpi, jpj, jpk, zkx, zky, zkz, zkepe )
+      REAL(wp), DIMENSION(jpi,jpj,jpk)  ::  zkx, zky, zkz, zkepe  
+      !!----------------------------------------------------------------------
 
       ! I. Momentum trends
@@ -283,5 +277,5 @@
             &      + vmo(jpdyn_bfr) + vmo(jpdyn_atf) ) / tvolv
             WRITE (numout,9513) umo(jpdyn_tau) / tvolu, vmo(jpdyn_tau) / tvolv
-            IF( ln_bfrimp )   WRITE (numout,9514) umo(jpdyn_bfri) / tvolu, vmo(jpdyn_bfri) / tvolv
+            IF( ln_drgimp )   WRITE (numout,9514) umo(jpdyn_bfri) / tvolu, vmo(jpdyn_bfri) / tvolv
          ENDIF
 
@@ -322,5 +316,5 @@
             &      + hke(jpdyn_bfr) + hke(jpdyn_atf) ) / tvolt
             WRITE (numout,9533) hke(jpdyn_tau) / tvolt
-            IF( ln_bfrimp )   WRITE (numout,9534) hke(jpdyn_bfri) / tvolt
+            IF( ln_drgimp )   WRITE (numout,9534) hke(jpdyn_bfri) / tvolt
          ENDIF
 
@@ -372,6 +366,4 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zkx, zky, zkz, zkepe )
-      !
    END SUBROUTINE glo_dyn_wri
 
Index: branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/TRD/trdken.F90
===================================================================
--- branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/TRD/trdken.F90	(revision 8093)
+++ branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/TRD/trdken.F90	(revision 8143)
@@ -13,11 +13,11 @@
    USE oce            ! ocean dynamics and tracers variables
    USE dom_oce        ! ocean space and time domain variables
+   USE phycst         ! physical constants
    USE sbc_oce        ! surface boundary condition: ocean
    USE zdf_oce        ! ocean vertical physics variables
+   USE zdfdrg         ! ocean vertical physics: bottom friction
+!!gm   USE dynhpg          ! hydrostatic pressure gradient   
+   USE ldftra         ! ocean active tracers lateral physics
    USE trd_oce        ! trends: ocean variables
-!!gm   USE dynhpg          ! hydrostatic pressure gradient   
-   USE zdfbfr         ! bottom friction
-   USE ldftra         ! ocean active tracers lateral physics
-   USE phycst         ! physical constants
    USE trdvor         ! ocean vorticity trends 
    USE trdglo         ! trends:global domain averaged
@@ -27,5 +27,4 @@
    USE iom            ! I/O manager library
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! Memory allocation
    USE ldfslp         ! Isopycnal slopes
 
@@ -74,5 +73,5 @@
       !!          diagnose separately the KE trend associated with wind stress
       !!              - bottom friction case (jpdyn_bfr):
-      !!          explicit case (ln_bfrimp=F): bottom trend put in the 1st level 
+      !!          explicit case (ln_drgimp=F): bottom trend put in the 1st level 
       !!                                       of putrd, pvtrd
       !
@@ -86,9 +85,7 @@
       INTEGER ::   ikbu  , ikbv     ! local integers
       INTEGER ::   ikbum1, ikbvm1   !   -       -
-      REAL(wp), POINTER, DIMENSION(:,:)   ::   z2dx, z2dy, zke2d   ! 2D workspace 
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zke                 ! 3D workspace 
-      !!----------------------------------------------------------------------
-      !
-      CALL wrk_alloc( jpi, jpj, jpk, zke )
+      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::   z2dx, z2dy, zke2d   ! 2D workspace 
+      REAL(wp), DIMENSION(jpi,jpj,jpk)      ::   zke                 ! 3D workspace 
+      !!----------------------------------------------------------------------
       !
       CALL lbc_lnk( putrd, 'U', -1. )   ;   CALL lbc_lnk( pvtrd, 'V', -1. )      ! lateral boundary conditions
@@ -125,5 +122,5 @@
          CASE( jpdyn_zdf )   ;   CALL iom_put( "ketrd_zdf"   , zke )    ! vertical diffusion 
          !                   !                                          ! wind stress trends
-                                 CALL wrk_alloc( jpi, jpj, z2dx, z2dy, zke2d )
+                                 ALLOCATE( z2dx(jpi,jpj) , z2dy(jpi,jpj) , zke2d(jpi,jpj) )
                            z2dx(:,:) = un(:,:,1) * ( utau_b(:,:) + utau(:,:) ) * e1e2u(:,:) * umask(:,:,1)
                            z2dy(:,:) = vn(:,:,1) * ( vtau_b(:,:) + vtau(:,:) ) * e1e2v(:,:) * vmask(:,:,1)
@@ -136,9 +133,9 @@
                            END DO
                                  CALL iom_put( "ketrd_tau"   , zke2d )  ! 
-                                 CALL wrk_dealloc( jpi, jpj     , z2dx, z2dy, zke2d )
+                                 DEALLOCATE( z2dx , z2dy , zke2d )
          CASE( jpdyn_bfr )   ;   CALL iom_put( "ketrd_bfr"   , zke )    ! bottom friction (explicit case) 
 !!gm TO BE DONE properly
-!!gm only valid if ln_bfrimp=F otherwise the bottom stress as to be recomputed at the end of the computation....
-!         IF(.NOT. ln_bfrimp) THEN
+!!gm only valid if ln_drgimp=F otherwise the bottom stress as to be recomputed at the end of the computation....
+!         IF(.NOT. ln_drgimp) THEN
 !            DO jj = 1, jpj    !   
 !               DO ji = 1, jpi
@@ -163,5 +160,5 @@
 !! reflechir a une possible sauvegarde du "vrai" un,vn pour le calcul de atf....
 !
-!         IF( ln_bfrimp ) THEN                                          ! bottom friction (implicit case)
+!         IF( ln_drgimp ) THEN                                          ! bottom friction (implicit case)
 !            DO jj = 1, jpj                                                  ! after velocity known (now filed at this stage)
 !               DO ji = 1, jpi
@@ -192,6 +189,4 @@
       END SELECT
       !
-      CALL wrk_dealloc( jpi, jpj, jpk, zke )
-      !
    END SUBROUTINE trd_ken
 
@@ -207,15 +202,12 @@
       !! ** Work only for full steps and partial steps (ln_hpg_zco or ln_hpg_zps)
       !!---------------------------------------------------------------------- 
-      INTEGER, INTENT(in) ::   kt    ! ocean time-step index
-      !!
-      REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(  out) ::   pconv
-      !
-      INTEGER  ::   ji, jj, jk                       ! dummy loop indices
-      INTEGER  ::   iku, ikv                         ! temporary integers
-      REAL(wp) ::   zcoef                            ! temporary scalars
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::  zconv  ! temporary conv on W-grid
-      !!----------------------------------------------------------------------
-      !
-      CALL wrk_alloc( jpi,jpj,jpk, zconv )
+      INTEGER                   , INTENT(in   ) ::   kt      ! ocean time-step index
+      REAL(wp), DIMENSION(:,:,:), INTENT(  out) ::   pconv   ! 
+      !
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      INTEGER  ::   iku, ikv     ! local integers
+      REAL(wp) ::   zcoef        ! local scalars
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  zconv  ! 3D workspace
+      !!----------------------------------------------------------------------
       !
       ! Local constant initialization 
@@ -240,6 +232,4 @@
       END DO
       !
-      CALL wrk_dealloc( jpi,jpj,jpk, zconv )      
-      !
    END SUBROUTINE ken_p2k
 
Index: branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdf_oce.F90
===================================================================
--- branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdf_oce.F90	(revision 8093)
+++ branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdf_oce.F90	(revision 8143)
@@ -4,6 +4,7 @@
    !! Ocean physics : define vertical mixing variables
    !!=====================================================================
-   !! history :  1.0  !  2002-06  (G. Madec) Original code
-   !!            3.2  !  2009-07  (G.Madec) addition of avm
+   !! history :  1.0  !  2002-06  (G. Madec)  Original code
+   !!            3.2  !  2009-07  (G. Madec)  addition of avm
+   !!            4.0  !  2017-05  (G. Madec)  drag coef. defined at t-point (zdfdrg.F90)
    !!----------------------------------------------------------------------
    USE par_oce        ! ocean parameters
@@ -54,8 +55,4 @@
    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:)   ::   avtb_2d        !: horizontal shape of background Kz profile
    REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:)     ::   avmb , avtb    !: background profile of avm and avt
-!!gm
-   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:)   ::   bfrua, bfrva   !: bottom friction coefficients
-   REAL(wp), PUBLIC, SAVE, ALLOCATABLE, DIMENSION(:,:)   ::   tfrua, tfrva   !: top    friction coefficients
-!!gm
 
    !!----------------------------------------------------------------------
@@ -71,9 +68,8 @@
       !!----------------------------------------------------------------------
       !
-      ALLOCATE( avm  (jpi,jpj,jpk) , avt  (jpi,jpj,jpk) , avs(jpi,jpj,jpk) ,        &
-         &      avm_k(jpi,jpj,jpk) , avt_k(jpi,jpj,jpk) , en (jpi,jpj,jpk) ,        & 
-         &      avmb(jpk) , bfrua(jpi,jpj) , tfrua(jpi, jpj) ,                      &
-         &      avtb(jpk) , bfrva(jpi,jpj) , tfrva(jpi, jpj) , avtb_2d(jpi,jpj) ,   &
-         &      avmu(jpi,jpj,jpk), avmv(jpi,jpj,jpk) ,  STAT = zdf_oce_alloc )
+      ALLOCATE( avm  (jpi,jpj,jpk) , avt  (jpi,jpj,jpk) , avs(jpi,jpj,jpk) ,   &
+         &      avm_k(jpi,jpj,jpk) , avt_k(jpi,jpj,jpk) , en (jpi,jpj,jpk) ,   & 
+         &      avmb(jpk) , avtb(jpk) ,  avtb_2d(jpi,jpj) ,                    &
+         &      avmu(jpi,jpj,jpk), avmv(jpi,jpj,jpk)    , STAT = zdf_oce_alloc )
          !
       IF( zdf_oce_alloc /= 0 )   CALL ctl_warn('zdf_oce_alloc: failed to allocate arrays')
Index: branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfdrg.F90
===================================================================
--- branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfdrg.F90	(revision 8093)
+++ branches/2017/dev_r7881_HPC09_ZDF/NEMOGCM/NEMO/OPA_SRC/ZDF/zdfdrg.F90	(revision 8143)
@@ -10,4 +10,6 @@
    !!            3.4  ! 2011-11  (H. Liu) implementation of semi-implicit bottom friction option
    !!                 ! 2012-06  (H. Liu) implementation of Log Layer bottom friction option
+   !!            4.0  ! 2017-05  (G. Madec) zdfbfr becomes zdfdrg + variable names change
+   !!                                     + drag defined at t-point + new user interface + top drag (ocean cavities)
    !!----------------------------------------------------------------------
 
@@ -28,5 +30,4 @@
    USE prtctl         ! Print control
    USE timing         ! Timing
-   USE wrk_nemo       ! Memory Allocation
 
    IMPLICIT NONE
@@ -137,8 +138,4 @@
       ENDIF
       !
-!!gm to be moved at the end of zdfphy
-      CALL lbc_lnk( pCdU, 'T', 1. )    ! Lateral boundary condition
-!!gm end
-      !
       IF(ln_ctl)   CALL prt_ctl( tab2d_1=pCdU, clinfo1=' Cd*U ')
       !
